"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NftStorageStorageDriver = exports.nftStorageStorage = void 0;
const nft_storage_1 = require("nft.storage");
const StorageDriver_1 = require("./StorageDriver");
const shared_1 = require("../../shared");
const nftStorageStorage = (token) => ({
    install(metaplex) {
        metaplex.setStorage(new NftStorageStorageDriver(metaplex, token));
    },
});
exports.nftStorageStorage = nftStorageStorage;
class NftStorageStorageDriver extends StorageDriver_1.StorageDriver {
    constructor(metaplex, token) {
        super(metaplex);
        this.nftStorage = new nft_storage_1.NFTStorage({ token });
    }
    getPrice(..._files) {
        return __awaiter(this, void 0, void 0, function* () {
            return shared_1.SolAmount.zero();
        });
    }
    upload(file) {
        return __awaiter(this, void 0, void 0, function* () {
            const { url } = yield this.nftStorage.store({
                image: file.toGlobalFile(),
                name: file.displayName,
                description: 'Unknown',
            });
            return url;
        });
    }
}
exports.NftStorageStorageDriver = NftStorageStorageDriver;
//# sourceMappingURL=NftStorageStorageDriver.js.map