"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlanUploadMetadataUsingBundlrOperationHandler = void 0;
const modules_1 = require("../../modules");
const filesystem_1 = require("../filesystem");
const BundlrStorageDriver_1 = require("./BundlrStorageDriver");
class PlanUploadMetadataUsingBundlrOperationHandler extends modules_1.PlanUploadMetadataOperationHandler {
    handle(operation) {
        const _super = Object.create(null, {
            handle: { get: () => super.handle }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const metadata = operation.input;
            const plan = yield _super.handle.call(this, operation);
            const storage = this.metaplex.storage();
            if (!(storage instanceof BundlrStorageDriver_1.BundlrStorageDriver)) {
                return plan;
            }
            const assets = this.getAssetsFromJsonMetadata(metadata);
            const mockUri = 'x'.repeat(100);
            const mockUris = assets.map(() => mockUri);
            const mockedMetadata = this.replaceAssetsWithUris(metadata, mockUris);
            const files = [...assets, filesystem_1.MetaplexFile.fromJson(mockedMetadata)];
            return plan.prependStep({
                name: 'Fund Bundlr wallet',
                handler: () => __awaiter(this, void 0, void 0, function* () {
                    const needsFunding = yield storage.needsFunding(files);
                    if (!needsFunding) {
                        return;
                    }
                    yield storage.fund(files);
                }),
            });
        });
    }
}
exports.PlanUploadMetadataUsingBundlrOperationHandler = PlanUploadMetadataUsingBundlrOperationHandler;
//# sourceMappingURL=PlanUploadMetadataUsingBundlrOperationHandler.js.map