"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MasterEditionLoader = void 0;
const programs_1 = require("../../../programs");
const shared_1 = require("../../../shared");
class MasterEditionLoader extends shared_1.Loader {
    constructor(nft) {
        super();
        this.nft = nft;
    }
    handle(metaplex) {
        return __awaiter(this, void 0, void 0, function* () {
            const masterEditionPda = yield programs_1.MasterEditionAccount.pda(this.nft.mint);
            const masterEditionInfo = yield metaplex.getAccountInfo(masterEditionPda);
            if (!masterEditionInfo) {
                return null;
            }
            return programs_1.MasterEditionAccount.fromAccountInfo(masterEditionInfo);
        });
    }
}
exports.MasterEditionLoader = MasterEditionLoader;
//# sourceMappingURL=MasterEditionLoader.js.map