import { PublicKey } from '@solana/web3.js';
import { IdentityDriver } from './IdentityDriver';
export const guestIdentity = () => ({
    install(metaplex) {
        metaplex.setIdentity(new GuestIdentityDriver(metaplex));
    },
});
export class GuestIdentityDriver extends IdentityDriver {
    publicKey;
    constructor(metaplex) {
        super(metaplex);
        this.publicKey = PublicKey.default;
    }
    async signMessage(_message) {
        // TODO: Custom errors.
        throw new Error('Guests cannot sign messages.');
    }
    async signTransaction(_transaction) {
        // TODO: Custom errors.
        throw new Error('Guests cannot sign transactions.');
    }
    async signAllTransactions(_transactions) {
        // TODO: Custom errors.
        throw new Error('Guests cannot sign transactions.');
    }
    async sendTransaction(transaction, signers, options) {
        return this.metaplex.connection.sendTransaction(transaction, signers, options);
    }
}
//# sourceMappingURL=GuestIdentityDriver.js.map