import { NFTStorage } from 'nft.storage';
import { StorageDriver } from './StorageDriver';
import { SolAmount } from "../../shared";
export const nftStorageStorage = (token) => ({
    install(metaplex) {
        metaplex.setStorage(new NftStorageStorageDriver(metaplex, token));
    },
});
export class NftStorageStorageDriver extends StorageDriver {
    nftStorage;
    constructor(metaplex, token) {
        super(metaplex);
        this.nftStorage = new NFTStorage({ token });
    }
    async getPrice(..._files) {
        return SolAmount.zero();
    }
    async upload(file) {
        const { url } = await this.nftStorage.store({
            image: file.toGlobalFile(),
            name: file.displayName,
            description: 'Unknown',
        });
        return url;
    }
}
//# sourceMappingURL=NftStorageStorageDriver.js.map