import { MasterEditionAccount } from "../../../programs";
import { Loader } from "../../../shared";
export class MasterEditionLoader extends Loader {
    nft;
    constructor(nft) {
        super();
        this.nft = nft;
    }
    async handle(metaplex) {
        const masterEditionPda = await MasterEditionAccount.pda(this.nft.mint);
        const masterEditionInfo = await metaplex.getAccountInfo(masterEditionPda);
        if (!masterEditionInfo) {
            return null;
        }
        return MasterEditionAccount.fromAccountInfo(masterEditionInfo);
    }
}
//# sourceMappingURL=MasterEditionLoader.js.map