import { TokenProgram } from "../../../programs";
import { OperationHandler } from "../../../shared";
import { FindNftsByMintListOperation } from '../operations';
export class FindNftsByOwnerOnChainOperationHandler extends OperationHandler {
    async handle(operation) {
        const owner = operation.input;
        const mints = await TokenProgram.tokenAccounts(this.metaplex.connection)
            .selectMint()
            .whereOwner(owner)
            .whereAmount(1)
            .getDataAsPublicKeys();
        const nfts = await this.metaplex.execute(new FindNftsByMintListOperation(mints));
        return nfts.filter((nft) => nft !== null);
    }
}
//# sourceMappingURL=FindNftsByOwnerOnChainOperationHandler.js.map