import { ModuleClient, Plan } from "../../shared";
import { Nft } from "./";
import { ConfirmOptions, PublicKey } from '@solana/web3.js';
import { UploadMetadataInput, UploadMetadataOutput, CreateNftInput, CreateNftOutput, UpdateNftInput, UpdateNftOutput } from './operations';
export declare class NftClient extends ModuleClient {
    findNftByMint(mint: PublicKey): Promise<Nft>;
    findNftsByMintList(mints: PublicKey[]): Promise<(Nft | null)[]>;
    findNftsByOwner(owner: PublicKey): Promise<Nft[]>;
    findNftsByCreator(creator: PublicKey, position?: number): Promise<Nft[]>;
    findNftsByCandyMachine(candyMachine: PublicKey, version?: 1 | 2): Promise<Nft[]>;
    uploadMetadata(input: UploadMetadataInput, confirmOptions?: ConfirmOptions): Promise<UploadMetadataOutput>;
    planUploadMetadata(input: UploadMetadataInput, confirmOptions?: ConfirmOptions): Promise<Plan<undefined, UploadMetadataOutput>>;
    createNft(input: CreateNftInput, confirmOptions?: ConfirmOptions): Promise<{
        nft: Nft;
    } & CreateNftOutput>;
    updateNft(nft: Nft, input: Omit<UpdateNftInput, 'nft'>, confirmOptions?: ConfirmOptions): Promise<{
        nft: Nft;
    } & UpdateNftOutput>;
}
