import { PublicKey } from '@solana/web3.js';
import { TokenStandard, Collection, Uses, Creator, MasterEditionV2Args } from '@metaplex-foundation/mpl-token-metadata';
import { Model } from "../../../shared";
import { MetadataAccount, MasterEditionAccount } from "../../../programs/tokenMetadata";
import { JsonMetadataLoader } from './JsonMetadataLoader';
import { MasterEditionLoader } from './MasterEditionLoader';
import { JsonMetadata } from './JsonMetadata';
export declare class Nft extends Model {
    /** The Metadata PDA account defining the NFT. */
    readonly metadataAccount: MetadataAccount;
    /** Loaders. */
    readonly metadataLoader: JsonMetadataLoader;
    readonly masterEditionLoader: MasterEditionLoader;
    /** Data from the Metadata account. */
    readonly updateAuthority: PublicKey;
    readonly mint: PublicKey;
    readonly name: string;
    readonly symbol: string;
    readonly uri: string;
    readonly sellerFeeBasisPoints: number;
    readonly creators: Creator[] | null;
    readonly primarySaleHappened: boolean;
    readonly isMutable: boolean;
    readonly editionNonce: number | null;
    readonly tokenStandard: TokenStandard | null;
    readonly collection: Collection | null;
    readonly uses: Uses | null;
    constructor(metadataAccount: MetadataAccount);
    get metadata(): JsonMetadata;
    get masterEditionAccount(): MasterEditionAccount | null;
    get masterEdition(): Partial<Omit<MasterEditionV2Args, 'key'>>;
    is(other: Nft | PublicKey): boolean;
}
