import { MetaplexFile } from "../../../drivers";
import { OperationHandler, Plan } from "../../../shared";
import { JsonMetadata } from '../models';
import { PlanUploadMetadataOperation, UploadMetadataInput, UploadMetadataOutput } from '../operations';
export declare class PlanUploadMetadataOperationHandler extends OperationHandler<PlanUploadMetadataOperation> {
    handle(operation: PlanUploadMetadataOperation): Promise<Plan<any, UploadMetadataOutput>>;
    protected uploadAssets(input: UploadMetadataInput): Promise<JsonMetadata>;
    protected uploadMetadata(metadata: JsonMetadata): Promise<UploadMetadataOutput>;
    protected getAssetsFromJsonMetadata(input: UploadMetadataInput): MetaplexFile[];
    protected replaceAssetsWithUris(input: UploadMetadataInput, replacements: string[]): JsonMetadata;
}
