import { PublicKey } from '@solana/web3.js';
import { bignum } from '@metaplex-foundation/beet';
import { Creator, Collection, Uses } from '@metaplex-foundation/mpl-token-metadata';
import { Operation, Signer } from "../../../shared";
export declare class CreateNftOperation extends Operation<CreateNftInput, CreateNftOutput> {
}
export interface CreateNftInput {
    uri: string;
    name?: string;
    symbol?: string;
    sellerFeeBasisPoints?: number;
    creators?: Creator[];
    collection?: Collection;
    uses?: Uses;
    isMutable?: boolean;
    maxSupply?: bignum;
    allowHolderOffCurve?: boolean;
    mint?: Signer;
    payer?: Signer;
    mintAuthority?: Signer;
    updateAuthority?: Signer;
    owner?: PublicKey;
    freezeAuthority?: PublicKey;
    tokenProgram?: PublicKey;
    associatedTokenProgram?: PublicKey;
}
export interface CreateNftOutput {
    mint: Signer;
    metadata: PublicKey;
    masterEdition: PublicKey;
    associatedToken: PublicKey;
    transactionId: string;
}
