export declare type OperationConstructor<I, O> = {
    new (input: I): Operation<I, O>;
};
export declare type InputOfOperation<T> = T extends Operation<infer I, unknown> ? I : never;
export declare type OutputOfOperation<T> = T extends Operation<unknown, infer O> ? O : never;
export declare class Operation<I, O> {
    input: I;
    output?: O;
    constructor(input: I);
}
