import { ConfirmOptions } from '@solana/web3.js';
import { Metaplex } from "../Metaplex";
import { InputOfOperation, Operation, OutputOfOperation } from './Operation';
export declare type OperationHandlerConstructor<T extends Operation<I, O>, I = InputOfOperation<T>, O = OutputOfOperation<T>> = {
    new (metaplex: Metaplex, confirmOptions?: ConfirmOptions): OperationHandler<T, I, O>;
};
export declare abstract class OperationHandler<T extends Operation<I, O>, I = InputOfOperation<T>, O = OutputOfOperation<T>> {
    metaplex: Metaplex;
    confirmOptions?: ConfirmOptions;
    constructor(metaplex: Metaplex, confirmOptions?: ConfirmOptions);
    abstract handle(operation: T): Promise<O>;
}
